---
policy: /ce/ca/aws/redshift/cluster-publicly-accessible
logic: /ce/ca/aws/redshift/cluster-publicly-accessible/prod.logic.yaml
executionTime: 2026-02-05T22:32:02.871971955Z
generationMs: 78
executionMs: 745
rows:
  - id: test1
    match: true
    status:
      expected: DISAPPEARED
      actual: DISAPPEARED
    conditionIndex:
      expected: 99
      actual: 99
    conditionText:
      expected: isDisappeared(CA10__disappearanceTime__c)
      actual: isDisappeared(CA10__disappearanceTime__c)
    runtimeError: {}
  - id: test2
    match: true
    status:
      expected: INAPPLICABLE
      actual: INAPPLICABLE
    conditionIndex:
      expected: 199
      actual: 199
    conditionText:
      expected: extract('CA10__status__c') != 'available'
      actual: extract('CA10__status__c') != 'available'
    runtimeError: {}
  - id: test3
    match: true
    status:
      expected: INCOMPLIANT
      actual: INCOMPLIANT
    conditionIndex:
      expected: 299
      actual: 299
    conditionText:
      expected: extract('CA10__publiclyAccessible__c') == 'Yes'
      actual: extract('CA10__publiclyAccessible__c') == 'Yes'
    runtimeError: {}
  - id: test4
    match: true
    status:
      expected: COMPLIANT
      actual: COMPLIANT
    conditionIndex:
      expected: 399
      actual: 399
    conditionText:
      expected: extract('CA10__publiclyAccessible__c') == 'No'
      actual: extract('CA10__publiclyAccessible__c') == 'No'
    runtimeError: {}
usedFiles:
  - path: /ce/ca/aws/redshift/cluster-publicly-accessible/policy.yaml
    md5Hash: 3435B946CFC937FF467F857718DAB239
    content: "---\nnames:\n  full: \"AWS Redshift Cluster is publicly accessible\"\
      \n  contextual: \"Cluster is publicly accessible\"\ndescription: >\n  Ensure\
      \ that Amazon Redshift clusters are not publicly accessible to reduce the \n\
      \  risk of unauthorized access and data exposure. Redshift clusters should be\
      \ launched \n  within a VPC and restricted to internal traffic.\ntype: \"COMPLIANCE_POLICY\"\
      \ncategories:\n  - \"SECURITY\"\nframeworkMappings:\n  - \"/frameworks/cloudaware/resource-security/public-and-anonymous-access\"\
      \n  - \"/frameworks/aws-fsbp-v1.0.0/redshift/01\"\nsimilarPolicies:\n  awsSecurityHub:\n\
      \    - name: \"[Redshift.1] Amazon Redshift clusters should prohibit public\
      \ access\"\n      url: \"https://docs.aws.amazon.com/securityhub/latest/userguide/redshift-controls.html#redshift-1\"\
      \n    "
  - path: /ce/ca/aws/redshift/cluster-publicly-accessible/prod.logic.yaml
    md5Hash: CD52323D43E6C6983EDCC5A3900FB7A1
    content: |
      ---
      inputType: "CA10__CaAwsRedshiftCluster__c"
      importExtracts:
        - file: "/types/CA10__CaAwsRedshiftCluster__c/object.extracts.yaml"
      testData:
        - file: "test-data.json"
      conditions:
        - status: "INAPPLICABLE"
          currentStateMessage: "The Cluster is not available."
          check:
            NOT_EQUAL:
              left:
                EXTRACT: "CA10__status__c"
              right:
                TEXT: "available"
        - status: "INCOMPLIANT"
          currentStateMessage: "The Redshift cluster is publicly accessible."
          remediationMessage: "Modify the cluster configuration to disable public access."
          check:
            IS_EQUAL:
              left:
                EXTRACT: "CA10__publiclyAccessible__c"
              right:
                TEXT: "Yes"
        - status: "COMPLIANT"
          currentStateMessage: "The Redshift cluster is not publicly accessible."
          check:
            IS_EQUAL:
              left:
                EXTRACT: "CA10__publiclyAccessible__c"
              right:
                TEXT: "No"
      otherwise:
        status: "UNDETERMINED"
        currentStateMessage: "Unexpected values in the fields."
  - path: /ce/ca/aws/redshift/cluster-publicly-accessible/test-data.json
    md5Hash: 1D11143CF5CDFEC8124921103A339FDE
    content: |-
      [
          {
              "CA10__publiclyAccessible__c": "Yes",
              "expectedResult": {
                  "runtimeError": null,
                  "conditionText": "isDisappeared(CA10__disappearanceTime__c)",
                  "conditionIndex": 99,
                  "status": "DISAPPEARED"
              },
              "context": {
                  "snapshotTime": "2026-02-01T22:39:15Z"
              },
              "Id": "test1",
              "CA10__disappearanceTime__c": "2026-02-01T22:39:15Z",
              "CA10__status__c": "paused"
          },
          {
              "CA10__publiclyAccessible__c": "Yes",
              "expectedResult": {
                  "runtimeError": null,
                  "conditionText": "extract('CA10__status__c') != 'available'",
                  "conditionIndex": 199,
                  "status": "INAPPLICABLE"
              },
              "context": {
                  "snapshotTime": "2026-02-01T22:39:15Z"
              },
              "Id": "test2",
              "CA10__disappearanceTime__c": null,
              "CA10__status__c": "paused"
          },
          {
              "CA10__publiclyAccessible__c": "Yes",
              "expectedResult": {
                  "runtimeError": null,
                  "conditionText": "extract('CA10__publiclyAccessible__c') == 'Yes'",
                  "conditionIndex": 299,
                  "status": "INCOMPLIANT"
              },
              "context": {
                  "snapshotTime": "2026-02-01T22:39:15Z"
              },
              "Id": "test3",
              "CA10__disappearanceTime__c": null,
              "CA10__status__c": "available"
          },
          {
              "CA10__publiclyAccessible__c": "No",
              "expectedResult": {
                  "runtimeError": null,
                  "conditionText": "extract('CA10__publiclyAccessible__c') == 'No'",
                  "conditionIndex": 399,
                  "status": "COMPLIANT"
              },
              "context": {
                  "snapshotTime": "2026-02-01T22:39:15Z"
              },
              "Id": "test4",
              "CA10__disappearanceTime__c": null,
              "CA10__status__c": "available"
          }
      ]
  - path: /types/CA10__CaAwsRedshiftCluster__c/object.extracts.yaml
    md5Hash: 978033E93A3BC4EEE31B6916039330FF
    content: |
      ---
      extracts:
      # Nullable. Values: available, modifying, creating ...
        - name: "CA10__status__c"
          value:
            FIELD:
              path: "CA10__status__c"
      # Nullable.
        - name: "CA10__createTime__c"
          value:
            FIELD:
              path: "CA10__createTime__c"
      # Nullable.
        - name: "CA10__cpuUtilizationAvg30d__c"
          value:
            FIELD:
              path: "CA10__cpuUtilizationAvg30d__c"
      # Nullable.
        - name: "CA10__diskReadIopsAvg30d__c"
          value:
            FIELD:
              path: "CA10__diskReadIopsAvg30d__c"
      # Nullable.
        - name: "CA10__diskWriteIopsAvg30d__c"
          value:
            FIELD:
              path: "CA10__diskWriteIopsAvg30d__c"
      # Nullable.
        - name: "CA10__logging__c"
          value:
            FIELD:
              path: "CA10__logging__c"
      # Nullable.
        - name: "CA10__automatedSnapshotRetentionPeriod__c"
          value:
            FIELD:
              path: "CA10__automatedSnapshotRetentionPeriod__c"
      # Text.
        - name: "CA10__encryption__c"
          value:
            FIELD:
              path: "CA10__encryption__c"
      # Text.
        - name: "CA10__masterUsername__c"
          value:
            FIELD:
              path: "CA10__masterUsername__c"
      # Text.
        - name: "CA10__versionUpgrade__c"
          value:
            FIELD:
              path: "CA10__versionUpgrade__c"
      # Values: Yes | No. Not nullable. Can't have no access, retrieved via redshift:DescribeClusters
        - name: "CA10__publiclyAccessible__c"
          value:
            FIELD:
              path: "CA10__publiclyAccessible__c"
      # Values: Enabled | Disabled. Not nullable. Can't have no access, retrieved via redshift:DescribeClusters
        - name: "CA10__enhancedVpcRouting2__c"
          value:
            FIELD:
              path: "CA10__enhancedVpcRouting2__c"
      # Number
        - name: "CA10__endpointPort2__c"
          value:
            FIELD:
              path: "CA10__endpointPort2__c"
script: |-
  CREATE TEMP FUNCTION mock_ExpectedResult()
  RETURNS ARRAY<STRUCT<
          Id STRING,
          expectedResult STRUCT<status STRING, conditionIndex DECIMAL, conditionText STRING, runtimeError STRING>
      >>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
    return [ {
    "Id" : "test1",
    "expectedResult" : {
      "runtimeError" : null,
      "conditionText" : "isDisappeared(CA10__disappearanceTime__c)",
      "conditionIndex" : 99,
      "status" : "DISAPPEARED"
    }
  }, {
    "Id" : "test2",
    "expectedResult" : {
      "runtimeError" : null,
      "conditionText" : "extract('CA10__status__c') != 'available'",
      "conditionIndex" : 199,
      "status" : "INAPPLICABLE"
    }
  }, {
    "Id" : "test3",
    "expectedResult" : {
      "runtimeError" : null,
      "conditionText" : "extract('CA10__publiclyAccessible__c') == 'Yes'",
      "conditionIndex" : 299,
      "status" : "INCOMPLIANT"
    }
  }, {
    "Id" : "test4",
    "expectedResult" : {
      "runtimeError" : null,
      "conditionText" : "extract('CA10__publiclyAccessible__c') == 'No'",
      "conditionIndex" : 399,
      "status" : "COMPLIANT"
    }
  } ];
  """;

  CREATE TEMP FUNCTION mock_CA10__CaAwsRedshiftCluster__c()
  RETURNS ARRAY<STRUCT<
      CA10__disappearanceTime__c TIMESTAMP,
      CA10__status__c STRING,
      CA10__publiclyAccessible__c STRING,
      Id STRING,
      context STRUCT<
          snapshotTime TIMESTAMP
      >
  >>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
    return [ {
    "context" : {
      "snapshotTime" : new Date("2026-02-01T22:39:15Z")
    },
    "CA10__disappearanceTime__c" : new Date("2026-02-01T22:39:15Z"),
    "CA10__status__c" : "paused",
    "CA10__publiclyAccessible__c" : "Yes",
    "Id" : "test1"
  }, {
    "context" : {
      "snapshotTime" : new Date("2026-02-01T22:39:15Z")
    },
    "CA10__status__c" : "paused",
    "CA10__publiclyAccessible__c" : "Yes",
    "Id" : "test2"
  }, {
    "context" : {
      "snapshotTime" : new Date("2026-02-01T22:39:15Z")
    },
    "CA10__status__c" : "available",
    "CA10__publiclyAccessible__c" : "Yes",
    "Id" : "test3"
  }, {
    "context" : {
      "snapshotTime" : new Date("2026-02-01T22:39:15Z")
    },
    "CA10__status__c" : "available",
    "CA10__publiclyAccessible__c" : "No",
    "Id" : "test4"
  } ];
  """;

  CREATE TEMP FUNCTION process_CA10__CaAwsRedshiftCluster__c(
      obj STRUCT<
          CA10__disappearanceTime__c TIMESTAMP,
          CA10__status__c STRING,
          CA10__publiclyAccessible__c STRING,
          Id STRING
      >,
      snapshotTime TIMESTAMP
  )
  RETURNS STRUCT<status STRING, conditionIndex DECIMAL, conditionText STRING, currentStateMessage STRING, currentStateReferences STRING, remediation STRING, runtimeError STRING>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
  var TextLib = new function () {
      this.normalize = function(arg) {
          return arg == null ? '' : arg.replace(/\s+/g, ' ').trim().toLowerCase();
      };
      this.isEmpty = function(arg) {
          return this.normalize(arg) == '';
      };
      this.isNotEmpty = function(arg) {
          return this.normalize(arg) != '';
      };
      this.equal = function(left, right) {
          return this.normalize(left) == this.normalize(right);
      };
      this.notEqual = function(left, right) {
          return this.normalize(left) != this.normalize(right);
      };
      this.startsWith = function(arg, substring) {
          return this.normalize(arg).startsWith(this.normalize(substring));
      };
      this.endsWith = function(arg, substring) {
          return this.normalize(arg).endsWith(this.normalize(substring));
      };
      this.contains = function(arg, substring) {
          return this.normalize(arg).includes(this.normalize(substring));
      };
      this.containsAll = function(arg, substrings) {
          if (substrings == null || substrings.length === 0) return false;
          let normalizedArg = this.normalize(arg);
          return substrings.every(sub => normalizedArg.includes(this.normalize(sub)));
      };
      this.containsAny = function(arg, substrings) {
          if (substrings == null || substrings.length === 0) return false;
          let normalizedArg = this.normalize(arg);
          return substrings.some(sub => normalizedArg.includes(this.normalize(sub)));
      };
  }();
      var references1 = [];
      // condition[0], conditionIndex:[0..99]
      references1.push('Deleted From AWS [CA10__disappearanceTime__c]: ' + obj.CA10__disappearanceTime__c);
      if (obj.CA10__disappearanceTime__c != null) {
          return {status: 'DISAPPEARED', conditionIndex: 99, conditionText: "isDisappeared(CA10__disappearanceTime__c)", currentStateMessage: "Object is deleted in the source", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
      }
      // condition[1], conditionIndex:[100..199]
      function extract3() { if (!this.out) { this.out = obj.CA10__status__c; } return this.out; };
      references1.push('Status [obj.CA10__status__c]: ' + obj.CA10__status__c);
      if (TextLib.notEqual(extract3.call(extract3), 'available')) {
          return {status: 'INAPPLICABLE', conditionIndex: 199, conditionText: "extract('CA10__status__c') != 'available'", currentStateMessage: "The Cluster is not available.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
      }
      // condition[2], conditionIndex:[200..299]
      function extract6() { if (!this.out) { this.out = obj.CA10__publiclyAccessible__c; } return this.out; };
      references1.push('Publicly Accessible [obj.CA10__publiclyAccessible__c]: ' + obj.CA10__publiclyAccessible__c);
      if (TextLib.equal(extract6.call(extract6), 'Yes')) {
          return {status: 'INCOMPLIANT', conditionIndex: 299, conditionText: "extract('CA10__publiclyAccessible__c') == 'Yes'", currentStateMessage: "The Redshift cluster is publicly accessible.", currentStateReferences: references1.join('\n'), remediation: "Modify the cluster configuration to disable public access.", runtimeError: null};
      }
      // condition[3], conditionIndex:[300..399]
      function extract9() { if (!this.out) { this.out = obj.CA10__publiclyAccessible__c; } return this.out; };
      if (TextLib.equal(extract9.call(extract9), 'No')) {
          return {status: 'COMPLIANT', conditionIndex: 399, conditionText: "extract('CA10__publiclyAccessible__c') == 'No'", currentStateMessage: "The Redshift cluster is not publicly accessible.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
      }
      return {status: 'UNDETERMINED', conditionIndex: 400, conditionText: "otherwise", currentStateMessage: "Unexpected values in the fields.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
  """;


  SELECT
    expectedResult.Id as Id,
    IF (
      IFNULL(expectedResult.expectedResult.status, '') = IFNULL(sObject.result.status, '')
      AND IFNULL(expectedResult.expectedResult.conditionIndex, -1) = IFNULL(sObject.result.conditionIndex, -1)
      AND IFNULL(expectedResult.expectedResult.conditionText, '') = IFNULL(sObject.result.conditionText, '')
      AND IFNULL(expectedResult.expectedResult.runtimeError, '') = IFNULL(sObject.result.runtimeError, ''),
      "MATCH",
      "FAIL"
    ) as match,
    expectedResult.expectedResult.status as expectedStatus, sObject.result.status as actualStatus,
    expectedResult.expectedResult.conditionIndex as expectedConditionIndex, sObject.result.conditionIndex as actualConditionIndex,
    expectedResult.expectedResult.conditionText as expectedConditionText, sObject.result.conditionText as actualConditionText,
    expectedResult.expectedResult.runtimeError as expectedRuntimeError, sObject.result.runtimeError as actualRuntimeError
  FROM UNNEST(mock_ExpectedResult()) expectedResult
  LEFT JOIN (
      SELECT
          sObject.CA10__disappearanceTime__c AS CA10__disappearanceTime__c,
          sObject.CA10__status__c AS CA10__status__c,
          sObject.CA10__publiclyAccessible__c AS CA10__publiclyAccessible__c,
          sObject.Id AS Id,
          process_CA10__CaAwsRedshiftCluster__c(
              STRUCT(
                  sObject.CA10__disappearanceTime__c AS CA10__disappearanceTime__c,
                  sObject.CA10__status__c AS CA10__status__c,
                  sObject.CA10__publiclyAccessible__c AS CA10__publiclyAccessible__c,
                  sObject.Id AS Id
              ),
              sObject.context.snapshotTime
          ) as result
      FROM UNNEST(mock_CA10__CaAwsRedshiftCluster__c()) AS sObject
  ) sObject ON sObject.Id = expectedResult.Id;
